// sndstretch_xmms.h
//
//    sndstretch_xmms - xmms-output plugin for adjusting
//                      pitch and speed of s16le data
//    Copyright (C) 2001  Florian Berger
//    Email: florian.berger@jk.uni-linz.ac.at
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License Version 2 as
//    published by the Free Software Foundation;
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//

#ifndef SNDSTRETCH_XMMS_H
#define SNDSTRETCH_XMMS_H

#include "xmms/plugin.h"
#include "xmms/configfile.h"

extern OutputPlugin sndstretch_op;
extern EffectPlugin sndstretch_ep;

void sndstretch_init           (void);
void sndstretch_about          (void);
void sndstretch_config         (void);
void sndstretch_get_volume     (int *l, int *r);
void sndstretch_set_volume     (int l, int r);
/* Set the volume */
int  sndstretch_open_audio     (AFormat fmt, int rate, int nch);
/* Open the device, if the device can't handle the given
   parameters the plugin is responsible for downmixing
   the data to the right format before outputting it */
void sndstretch_write_audio    (void *ptr, int length);
/* The input plugin calls this to write data to the output buffer */
void sndstretch_close_audio    (void);
void sndstretch_flush          (int time);
/* Flush the buffer and set the plugins internal timers to time */
void sndstretch_pause          (short paused);
/* Pause or unpause the output */
int  sndstretch_buffer_free    (void);
/* Return the amount of data that can be written to the buffer,
   two calls to this without a call to write_audio should make
   the plugin output audio directly */
int  sndstretch_buffer_playing (void);
/* Returns TRUE if the plugin currently is playing some audio,
   otherwise return FALSE */
int  sndstretch_output_time    (void);
/* Return the current playing time */
int  sndstretch_written_time   (void);
/* Return the length of all the data that has been written to buffer */

int sndstretch_mod_samples (gpointer *ptr, gint length, AFormat fmt, gint srate, gint nch);
/* Modify samples for effect plugin */


#endif /* SNDSTRETCH_XMMS_H */